#!/usr/bin/env python
# encoding=utf-8

"""
* @ DDoS Defender Tool for Python
* @ 报警邮件发送类
* @ 封装了普通发送与SSL加密发送模式
##############################################################################
# DDoS-Defender version 2.1.0 Author: Sunshine Koo <350311204@qq.com>        #
# Modfiy: guzhiqiang, 2012-09-25 17:11:30                                    #
# Blog: http://www.hit008.com , http://www.ywjt.org                          #
##############################################################################
# This program is distributed under the "Artistic License" Agreement         #
# The LICENSE file is located in the same directory as this program. Please  #
# read the LICENSE file before you make copies or distribute this program    #
##############################################################################
"""

import sys
sys.path.append("..")
import smtplib
from email.header import Header
from email.mime.text import MIMEText
from conf.ddos import ADMIN_EMAIL,SMTP_USER,SMTP_PASSWD,SMTP_SERVER,SMTP_TYPE
from lib.ddosLog import save_log


class PyEmail:
    sender = ''     #发送者
    receiver = []   #收接人列表
    smtpserver = '' #SMTP服务器
    username = ''   #用户名
    password = ''   #验证密码
    type = ''       #发信模式,默认不使用ssl
    
    """
    @name: 构造函数
    @desc: 读取配置文件,初始化变量
    """
    def __init__(self):
        global ADMIN_EMAIL,SMTP_USER,SMTP_PASSWD,SMTP_SERVER,SMTP_TYPE
        self.receiver = ADMIN_EMAIL
        self.smtpserver = SMTP_SERVER
        self.username = SMTP_USER
        self.password = SMTP_PASSWD
        self.type = SMTP_TYPE
        if not SMTP_USER.find('@'):
            self.sender = SMTP_SERVER.replace(SMTP_SERVER.split('.')[0]+'.',SMTP_USER+'@')
        else:
            self.sender = SMTP_USER    
        

    """
    @name: 普通发信模式
    @desc: 不需要SSl认证
    """
    def nonsend(self,subject,msg):
        self.__init__()
        msg = MIMEText(msg,'plain','utf-8') #中文需参数‘utf-8’，单字节字符不需要
        msg['Subject'] = subject
        smtp = smtplib.SMTP()
        smtp.connect(self.smtpserver)
        smtp.login(self.username, self.password)
        smtp.sendmail(self.sender, self.receiver, msg.as_string())
        smtp.quit()
        
    """
    @name: SSL发信模式
    @desc: 支持google邮箱
    """
    def sslsend(self,subject,msg):
        self.__init__()
        msg = MIMEText(msg,'plain','utf-8') #中文需参数‘utf-8’，单字节字符不需要
        msg['Subject'] = Header(subject, 'utf-8')
        smtp = smtplib.SMTP()
        smtp.connect(self.smtpserver)
        smtp.ehlo()
        smtp.starttls()
        smtp.ehlo()
        smtp.set_debuglevel(1)
        smtp.login(self.username, self.password)
        smtp.sendmail(self.sender, self.receiver, msg.as_string())
        smtp.quit()
        
    """
    @name: 发送邮件
    """    
    def sendto(self,subject,msg):
        if str(self.type) == 'ssl':
            try:
                self.sslsend(subject,msg)
                save_log('MAIL','Send mail Success.')
            except Exception, errmsg:
                save_log('MAIL','Send mail failed to: %s' % errmsg)
                return False
        else:
            try:
                self.nonsend(subject,msg)
                save_log('MAIL','Send mail Success.')
            except Exception, errmsg:
                save_log('MAIL','Send mail failed to: %s' % errmsg)
                return False
    
