#!/usr/bin/env python
# encoding=utf-8

"""
* @ DDoS Defender Tool for Python
* @ 主处理逻辑类
* @ 负责IP检测/过滤/封锁/解封过程
##############################################################################
# DDoS-Defender version 2.1.0 Author: Sunshine Koo <350311204@qq.com>        #
# Modfiy: guzhiqiang, 2012-09-25 17:11:30                                    #
# Blog: http://www.hit008.com , http://www.ywjt.org                          #
##############################################################################
# This program is distributed under the "Artistic License" Agreement         #
# The LICENSE file is located in the same directory as this program. Please  #
# read the LICENSE file before you make copies or distribute this program    #
##############################################################################
"""

import sys
sys.path.append("..")
import os
import commands
import datetime
from time import sleep
from conf.ddos import NO_OF_CONNECTIONS, ADMIN_EMAIL, WHITELISTED_IPS, BAN_PERIOD, REXEC_TIME, MONT_PORT, BLOCK_FILE
from lib.ddosMail import PyEmail
from lib.ddosLog import save_log

#获取根目录路径
PROC_DIR =  os.path.abspath('..')

#日志存放目录
LOGS_DIR = PROC_DIR + '/logs/'

class DDoSDefender:
    maximumAllowedConnectionsPerIP = 100 #最大连接数
    adminEmail = '' #管理员邮箱
    whitelistIPs = ['127.0.0.1','0.0.0.0'] #白名单
    blockTime = 3600 #封锁时间
    blockedIPs = {}  #黑名单
    exectime = 1     #检测间隔
    montport = '*'   #监控端口
    blockfile = ''  #黑名单列表
    keepRunning = True

    def __init__(self):
	    self.setVars()

    '''
    @name: 初始化赋值
    '''
    def setVars(self):
        global NO_OF_CONNECTIONS, ADMIN_EMAIL, WHITELISTED_IPS, BAN_PERIOD, REXEC_TIME, MONT_PORT
        self.maximumAllowedConnectionsPerIP = NO_OF_CONNECTIONS
        self.adminEmail = ADMIN_EMAIL
        self.whitelistIPs = WHITELISTED_IPS
        self.blockTime = BAN_PERIOD
        self.exectime = REXEC_TIME
        self.montport = MONT_PORT
        self.blockfile = BLOCK_FILE
        self.Pymail = PyEmail()


    '''
    @name: 主程序逻辑
    @desc: 实现动态连接分析、封锁IP
    '''
    def protectSystem(self):
        self.setVars()
        
        while self.keepRunning:
            
            #解封
            self.unblockIPs(LOGS_DIR+self.blockfile)
            
            #尝试重载黑名单到iptables
            self.reloadBlockList(LOGS_DIR+self.blockfile)
            
            result = commands.getoutput("core_netstat|grep -vE '"+'|'.join(self.whitelistIPs)+"'|grep -E '\[" +'|'.join(self.montport)+ "\]'|awk '{print $3}' | cut -d\" \" -f1 | sort | uniq -c")
            #如果结果为空跳过本次检测
            if not result.strip():
                continue
            result = result.split("\n")

            for line in result:
                #对于直接使用netstat时有效
                if 'Address' in line or 'servers' in line:
                    continue
            
                #去掉两端空格 
                line = line.strip()
                line = line.split(' ')

                #符合封锁条件
                if int(line[0]) >= self.maximumAllowedConnectionsPerIP:
                    line[1] = str(line[1])
                    
                    #排除白名单和去除重复的黑名单
                    if not line[1] in self.whitelistIPs and not self.blockedIPs.has_key(line[1]):
                    #封锁指定IP    
                        os.system('/sbin/iptables -I INPUT -s '+line[1]+' -j DROP')

                        now = datetime.datetime.now()
                    
                        #黑名单入列{'10.0.0.l':'now+3600'}
                        self.blockedIPs[line[1]] = now+datetime.timedelta(seconds=self.blockTime)
                        #save_log('TEST',str(self.blockedIPs))
                        #记录到文件{ip,lockTime,unloackTime}
                        self.saveLog(LOGS_DIR+self.blockfile,line[1] + ',' + str(now) + ',' + str(self.blockedIPs[line[1]]))
                        nowDisplay = str(now.strftime("%m/%d/%Y %H:%M"))

                        #发送报警邮件
                        if self.adminEmail != '':
                            self.Pymail.sendto('IP addresses banned on '+nowDisplay,'Banned '+line[1]+' on '+nowDisplay+' due to '+str(line[0])+' connections.')

                        #同时写到log里
                        save_log('LOCK',line[1]+" has been blocked,It has "+str(line[0])+" connections to server.")

            #监控间隔
            sleep(self.exectime)


    """
    @name: 解封IP过程
    @desc: 根据定义的时间，解封黑名单
    """
    def unblockIPs(self,file):
        fp = open(file,'r')
        
        try:
            while True:
                blockStr = fp.readline()
                if len(blockStr) == 0:
                    break
                blockStr = blockStr.replace('\n','')
                blockStr = blockStr.split(',')
                now = datetime.datetime.now()
                if str(now) >= blockStr[2]:
                    os.system('/sbin/iptables -D INPUT -s '+blockStr[0]+' -j DROP')
                    #同步清理黑名单列表
                    os.system('/bin/sed -i \'/'+blockStr[0]+'/d\' '+file)
                    save_log('UNLOCK',blockStr[0]+ " has been unblocked.")
                    del self.blockedIPs[str(blockStr[0])]
                fp.close()
        except:
            pass
                
    
    """
    @name: 文件写入
    @desc: 记录黑名单列表等
    """    
    def saveLog(self,file,content):
        try:
            fp = open(file,'a')
        except IOError as e:
            if e.errno == errno.EACCES:
                save_log('READ','Open'+file+'file Failed...')
            raise
        else:
            fp.write(content+"\n")
            fp.close()


    """
    @name: 重载黑名单列表
    @desc: 程序中断重启后,使block_ips与iptables列表同步   
    """
    def reloadBlockList(self,file):
        fp = open(file,'a+')
        #从block_ips文件重载到iptables
        try:
            while True:
                blockStr = fp.readline()
                if len(blockStr) == 0:
                    break
                blockStr = blockStr.replace('\n','')
                blockStr = blockStr.split(',')
                ipTabs = commands.getoutput("/sbin/iptables -nL INPUT|grep DROP|awk '{print $4}'")
                ipTabs = ipTabs.split('\n')
                if not blockStr[0] in ipTabs:
                    os.system('/sbin/iptables -I INPUT -s ' + blockStr[0] + ' -j DROP')
                    save_log('REBL',blockStr[0]+' reload in iptables Success.')
            fp.close()
            
        except:
            pass
        